% Program for solving the Initial-Boundary-value Problem
%	v_t + ( v^2 / 2 )_x = 0
% using the upwind scheme
clear;
T=1
Ne=2;
Cm=2;
MJ=Cm*10^Ne
%N=1*10^Ne
cfl=.5;
right=2;
left=-2;
%k=T/(N)					% should suffice k<=h for stability
h=(right-left)/(MJ)
k=h*cfl;
N=ceil(T/k);
k=T/N;
x=(left:h:right);

u=zeros(MJ+1,N+1);
%uold(1:MJ+1)=0;




%%%%%%%%%%%% Setting the initial conditions specified by function u0 %%%%%%%%%%

for j=1:MJ+1
	u(j,1)=u0((j-1)/MJ*(right-left)+left);
 %uold(j)=   u0((j-1)/MJ*(right-left)+left);
end


%%%%%%%%%%%% 			Boundary condition 		    %%%%%%%%%%%

for n=2:(N+1)
u(1,n)=u0(left);
u(MJ+1,n)=u0(right);
end



%%%%%%%%%%%%%% Upwind Method %%%%%%%%%%%%%%%%

for n=1:N
%unew(1)=u0(left);
%unew(MJ+1)=u0(right);
% 		Central Diffquot fails
%	u(2:MJ,n+1)=u(2:MJ,n) - k/h/2*( u(2:MJ,n) .* ( u(3:(MJ+1),n)-u(1:(MJ-1),n) ) ); 	% discr. v*v_x
%	u(2:MJ,n+1)=u(2:MJ,n) - k/h/4*( u(3:(MJ+1),n).^2 - u(1:(MJ-1),n).^2 ); 		% discr. (v^2)_x


%		Left sided Diffquot for x<=0 and right sided Diffquot for x>0 with discr. of v*v_x fails
%	u(2:(MJ/2+1),n+1)=u(2:(MJ/2+1),n) - k/h/2*( u(2:(MJ/2+1),n) .* ( u(2:(MJ/2+1),n)-u(1:(MJ/2),n) ) ); 
%	u((MJ/2+2):MJ,n+1)=u((MJ/2+2):MJ,n) - k/h/2*( u((MJ/2+2):MJ,n) .* ( u((MJ/2+3):(MJ+1),n)-u((MJ/2+2):MJ,n) ) ); 


%		Conservative Upwind

for j=2:MJ
%    unew(j)=uold(j)-k/h*uold(j+1)*(uold(j)-uold(j-1));
%    if ((uold(j)-uold(j+1))==0)
%           unew(j)=uold(j);
%       elseif ((uold(j)^2-uold(j+1)^2)/(uold(j)-uold(j+1)) >= 0)
%           unew(j)=uold(j) - k/h/2*( uold(j)^2 - uold(j-1)^2 ); 	
%       else
%		unew(j)=uold(j) - k/h/2*( uold(j+1)^2 - uold(j)^2 ); 	
%    end    
	if (u(j,n)-u(j+1,n) == 0)
        flxr=u(j,n)^2/2;
    else
    if ((u(j,n)^2-u(j+1,n)^2)/(u(j,n)-u(j+1,n)) >= 0) 
        flxr=u(j,n)^2/2;
    else
        flxr=u(j+1,n)^2/2;
    end
end    
    if (u(j-1,n)-u(j,n) == 0)
        flxl=u(j,n)^2/2;
    else
    if ((u(j-1,n)^2-u(j,n)^2)/(u(j-1,n)-u(j,n)) >= 0) 
        flxl=u(j-1,n)^2/2;
    else
        flxl=u(j,n)^2/2;
    end
end
    u(j,n+1)=u(j,n) - k/h*( flxr - flxl ); 	
end
%sol=
%plot(x,unew,'*-');
%set(sol,'erasemode','xor')
%axis([-2,2.05,min(unew),max(unew)]);
%n
%uold=unew;
figure(1);
plot(x,u(:,n),'*-');
  %set(sol,'erasemode','xor')

  % hold on;
  drawnow

end



%ibvp=u(1:(MJ+1),N+1);



%%%%%% Plotting 3D %%%%
figure(2)
[XX,Y] = meshgrid(x,k*(0:N));
mesh(XX,Y,u');

%%%%%% Plotting 2D %%%%

%plot(1:(MJ+1),ibvp)
