% Program for solving the Initial-Boundary-value Problem
%	v_t + ( v^2 / 2 )_x = 0
% using the Godunov scheme
clear;
T=1
Ne=2;
Cm=2;
MJ=Cm*10^Ne
%N=1*10^Ne
cfl=.5;
right=2;
left=-2;
%k=T/(N)					% should suffice k<=h for stability
h=(right-left)/(MJ)
k=h*cfl;
N=ceil(T/k);
k=T/N;
x=(left:h:right);

u=zeros(MJ+1,N+1);




%%%%%%%%%%%% Setting the initial conditions specified by function u0 %%%%%%%%%%

for j=1:MJ+1
	u(j,1)=u0((j-1)/MJ*(right-left)+left);
end


%%%%%%%%%%%% 			Boundary condition 		    %%%%%%%%%%%

for n=2:(N+1)
u(1,n)=u0(left);
u(MJ+1,n)=u0(right);

end

F=zeros(MJ,1);

%%%%%%%%%%%%%% MacCormack's Method %%%%%%%%%%%%%%%%

for n=1:N
	for j=1:MJ
        F(j)=u(j+1,n)*(u(j+1,n)-u(j,n));
%          F(j)=(u(j,n)^2)/2;      
% 		if u(j,n)<=u(j+1,n)
% 			if (u(j,n)<0) & (u(j+1,n)>0)
% 				F(j)=0;			% min f(u) for u_j<u<u_j+1 = 0 at u=0
% 			else 
% 				us=min(abs([u(j,n),u(j+1,n)]));
%                 F(j)=us^2/2;
% 			end
% 		else	
%             us=max(abs([u(j,n),u(j+1,n)]));
%               F(j)=us^2/2;
% 		end
	end	
	u(2:MJ,n+1) = u(2:MJ,n) - k/h * F(1:(MJ-1));
%    (F(2:MJ)-F(1:(MJ-1)));
    figure(1);
    plot(x,u(:,n+1),'*-');
  %set(sol,'erasemode','xor')


  drawnow

end




%%%%%% Plotting 3D %%%%
figure(2)
[XX,Y] = meshgrid(x,k*(0:N));
mesh(XX,Y,u');

%%%%%% Plotting 2D %%%%

%plot(1:(MJ+1),u)
